


#include <stdio.h> // for NULL

// use a round function instead of typecasts like
// longvar = (long)floatvar, which forces hidden _ftol routine to
// be linked in, and the prototype to _ftol is not documented
extern long round(double);

// for debugging
extern void ShowIntValue( char* Msg, int Value );

extern void RaiseDelphiException( char* Msg );

/* MB. Dec 11, 2001 Add callback */
typedef void (*TProgressFunc)( __int8 Progress, long CallBackData );

long BoundInteger( long Value, long MinValue, long MaxValue )
{
    if (Value < MinValue)
        return (MinValue);

    if (Value > MaxValue)
        return MaxValue;

    return Value;
}


__int8 DoProgress( TProgressFunc ProgressFunc,
                   long          CallBackData,
                   long          Current,
                   long          Min,
                   long          Max,
                   __int8        LastPercent )
{
     __int8 Percent;

    if (ProgressFunc == NULL)
        return (0);

    if ((Max-Min) <= 0)
        Percent = 0;
    else
        Percent = BoundInteger( ((Current - Min) * 100) / (Max - Min),
                                 0, 100 );

    if (Percent != LastPercent)
        ProgressFunc(Percent, CallBackData);

    return (Percent);
}


#include "windows.h"
#include "winnt.h" // for BOOLEAN

#include "gbm.c"
#include "gbmhelp.c"
#include "gbmpcx.c"
#include "gbmtga.c"
#include "gbmbmp.c"


#include "transupp.c"
#include "jfdctint.c"
#include "jfdctfst.c"
#include "jfdctflt.c"
#include "jcapimin.c"
#include "jcapistd.c"
#include "jccoefct.c"
#include "jccolor.c"

#include "jchuff.c"
#include "jcinit.c"
#include "jcmainct.c"
#include "jcmaster.c"

#include "jcomapi.c"
#include "jcparam.c"
#include "jcphuff.c"
#include "jcprepct.c"
#include "jcsample.c"
#include "jctrans.c"

#include "jcdctmgr.c"

#include "jidctflt.c"

#include "jdatasrc.c"
#include "jdatadst.c"
#include "jdapimin.c"
#include "jdapistd.c"
#include "jcmarker.c"
#include "jdcoefct.c"
#include "jdcolor.c"
#include "jddctmgr.c"
#include "jdhuff.c"
#include "jdinput.c"
#include "jdmainct.c"

#include "jdmarker.c"
#include "jdmaster.c"
#include "jdmerge.c"
#include "jdphuff.c"

#include "jdpostct.c"
#include "jdsample.c"
#include "jdtrans.c"

#include "jerror.c"

#include "jidctfst.c"
#include "jidctint.c"
#include "jidctred.c"

#include "jmemmgr.c"
#include "jmemnobs.c"
#include "jquant1.c"
#include "jquant2.c"
#include "jutils.c"


#include "twrite.c"
#include "tstrip.c"
#include "tclose.c"
#include "tcodec.c"
#include "tcompres.c"
#include "tdir.c"
#include "tdirinfo.c"
#include "tdirrd.c"
#include "tdmpmode.c"
#include "terror.c"
#include "tfax3.c"
#include "tflush.c"
#include "tjpeg.c"
#include "tlzw.c"
//#include "tpixarlog.c"
#include "tthunder.c"
//#include "tluv.c"
//#include "tnext.c"
#include "ttile.c"
#include "tversion.c"
#include "twarning.c"
#include "twin32.c"
#include "tzip.c"
#include "topen.c"
#include "tpckbits.c"
#include "tpredict.c"
#include "tread.c"
#include "tswab.c"

#include "taux.c"
#include "tdirwrit.c"
#include "tgetimg.c"

#include "xtif_dir.c"

#include "infutil.c"
#include "infcodes.c"
#include "adler32.c"
#include "inftrees.c"
#include "inffast.c"
#include "zutil.c"
#include "infblock.c"


#include "pngrtran.c"
#include "pngwrite.c"
#include "pngrutil.c"
#include "pngwutil.c"
#include "pngread.c"
#include "pngwtran.c"
#include "pngtrans.c"
#include "png.c"
#include "pngmem.c"
#include "pngrio.c"
#include "pngwio.c"
#include "pngget.c"
#include "pngset.c"
#include "pngerror.c"
#include "crc32.c"


/* MB Gif lib is a bit buggy, causing GPF's on some files. Also for
	legal reasons, Gif support is not included
#include "egif_lib.c"
#include "dgif_lib.c"
#include "gifalloc.c"
#include "gif_hash.c"
#include "gif_err.c"
*/


// some RTL functions. Many other RTL functions are implemented in pascal
// in the EnCRtl.Pas unit
char * strrchr( const char *s, int c )
{
	char *ss;
	int i;

	for(i = strlen( s ) + 1, ss = s+i; i; i--)
		{
		if( *(--ss) == (char)c )  return( (char *)ss );
		}

	return( 0 );
}

char * strpbrk(const char *s1, const char *s2)
{
	char *srchs2;

	while (*s1)
	{
		for (srchs2 = s2; *srchs2; srchs2++)
			if (*s1 == *srchs2)
				return((char *)s1);
		s1++;
	}
	return (0);
}

void jpeg_init_decompress( struct jpeg_error_mgr**          errormgr_pp,
						   struct jpeg_decompress_struct**  decompressstruct_pp )
{
	*errormgr_pp         = malloc(sizeof(struct jpeg_error_mgr));

	*decompressstruct_pp = malloc(sizeof(struct jpeg_decompress_struct));

	(**decompressstruct_pp).err = jpeg_std_error(*errormgr_pp);

	jpeg_create_decompress(*decompressstruct_pp);
}

void jpeg_decompress_done( struct jpeg_error_mgr*          errormgr_p,
						   struct jpeg_decompress_struct** decompressstruct_p )
{
	jpeg_destroy_decompress(decompressstruct_p);
	free(decompressstruct_p);
	free(errormgr_p);
}

void jpeg_init_compress( struct jpeg_error_mgr**          errormgr_pp,
						 struct jpeg_compress_struct**  compressstruct_pp )
{
	*errormgr_pp         = malloc(sizeof(struct jpeg_error_mgr));

	*compressstruct_pp = malloc(sizeof(struct jpeg_compress_struct));

	(**compressstruct_pp).err = jpeg_std_error(*errormgr_pp);

	jpeg_create_compress(*compressstruct_pp);
}

void jpeg_compress_done( struct jpeg_error_mgr*          errormgr_p,
						 struct jpeg_compress_struct** compressstruct_p )
{
	jpeg_destroy_compress(compressstruct_p);
	free(compressstruct_p);
	free(errormgr_p);
}

void jpeg_get_info( j_decompress_ptr cinfo,
					JDIMENSION*      width,
					JDIMENSION*	     height,
					int*	         components,
					UINT8*		     resunit,
					UINT16*      	 xres,
					UINT16* 		 yres,
					int*             file_colorspace )
{
	*width           = cinfo->output_width;
	*height          = cinfo->output_height;
	*components      = cinfo->output_components;
	*resunit         = cinfo->density_unit;
	*xres		     = cinfo->X_density;
	*yres	         = cinfo->Y_density;
	*file_colorspace = (int)cinfo->jpeg_color_space;
}

void jpeg_set_out_colorspace( j_decompress_ptr cinfo,
							  int              colorspace )
{
	cinfo->out_color_space = (J_COLOR_SPACE)colorspace;
}

void jpeg_set_info( j_compress_ptr   cinfo,
					JDIMENSION       width,
					JDIMENSION	     height,
					int 	         components,
					UINT8		     resunit,
					UINT16      	 xres,
					UINT16  		 yres,
					int              file_colorspace,
					int              quality,
					int              progressive,
					int              optimized_huffman )
{
	cinfo->image_width        = width;
	cinfo->image_height       = height;
	cinfo->input_components   = components;
	cinfo->in_color_space     = (J_COLOR_SPACE)file_colorspace;

	jpeg_set_defaults(cinfo);

	/* the resolution must be set after jpeg_set_defaults */
	cinfo->density_unit       = resunit;
	cinfo->X_density          = xres;
	cinfo->Y_density          = yres;

	jpeg_set_quality(cinfo, quality, TRUE);

	if (progressive)
		jpeg_simple_progression(cinfo);

	cinfo->optimize_coding = optimized_huffman;
}


void main()
{
}
