/*
 * Private Extended TIFF library interface.
 *
 *  uses private LIBTIFF interface.
 *
 *  The portions of this module marked "XXX" should be
 *  modified to support your tags instead.
 *
 *  written by: Niles D. Ritter
 *
 */

#ifndef __xtiffiop_h
#define __xtiffiop_h

#include "tiffiop.h"
#include "xtiffio.h"

/**********************************************************************
 *               User Configuration
 **********************************************************************/

/* XXX - Define number of your extended tags here */
#define NUM_XFIELD 20
#define XFIELD_BASE (FIELD_LAST-NUM_XFIELD)

/*  XXX - Define your Tag Fields here  */
#define	FIELD_USER1      (XFIELD_BASE+0)
#define	FIELD_USER2      (XFIELD_BASE+1)
#define	FIELD_USER3      (XFIELD_BASE+2)
#define	FIELD_USER4      (XFIELD_BASE+3)
#define	FIELD_USER5      (XFIELD_BASE+4)
#define	FIELD_USER6      (XFIELD_BASE+5)
#define	FIELD_USER7      (XFIELD_BASE+6)
#define	FIELD_USER8      (XFIELD_BASE+7)
#define	FIELD_USER9      (XFIELD_BASE+8)
#define	FIELD_USER10     (XFIELD_BASE+9)
#define	FIELD_USER11     (XFIELD_BASE+10)
#define	FIELD_USER12     (XFIELD_BASE+11)
#define	FIELD_USER13     (XFIELD_BASE+12)
#define	FIELD_USER14     (XFIELD_BASE+13)
#define	FIELD_USER15     (XFIELD_BASE+14)
#define	FIELD_USER16     (XFIELD_BASE+15)
#define	FIELD_USER17     (XFIELD_BASE+16)
#define	FIELD_USER18     (XFIELD_BASE+17)
#define	FIELD_USER19     (XFIELD_BASE+18)
#define	FIELD_USER20     (XFIELD_BASE+19)


/* XXX - Define Private directory tag structure here */
struct XTIFFDirectory {
	char*    UserField1;
	char*    UserField2;
	char*    UserField3;
	char*    UserField4;
	char*    UserField5;
	char*    UserField6;
	char*    UserField7;
	char*    UserField8;
	char*    UserField9;
	char*    UserField10;
	char*    UserField11;
	char*    UserField12;
	char*    UserField13;
	char*    UserField14;
	char*    UserField15;
	char*    UserField16;
	char*    UserField17;
	char*    UserField18;
	char*    UserField19;
	char*    UserField20;
};
typedef struct XTIFFDirectory XTIFFDirectory;

/**********************************************************************
 *    Nothing below this line should need to be changed by the user.
 **********************************************************************/

struct xtiff {
	TIFF 		*xtif_tif;	/* parent TIFF pointer */
	uint32		xtif_flags;
#define       XTIFFP_PRINT   0x00000001
	XTIFFDirectory	xtif_dir;	/* internal rep of current directory */
	TIFFVSetMethod	xtif_vsetfield;	/* inherited tag set routine */
	TIFFVGetMethod	xtif_vgetfield;	/* inherited tag get routine */
	TIFFPrintMethod	xtif_printdir;  /* inherited dir print method */
};
typedef struct xtiff xtiff;


#define PARENT(xt,pmember) ((xt)->xtif_ ## pmember) 
#define TIFFMEMBER(tf,pmember) ((tf)->tif_ ## pmember) 
#define XTIFFDIR(tif) ((xtiff *)TIFFMEMBER(tif,clientdir))
	
/* Extended TIFF flags */
#define XTIFF_INITIALIZED 0x80000000
	
#endif /* __xtiffiop_h */
